"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Model = (function () {
    function Model(data) {
        var me = this;
        data = data || {};
        me.data = data;
        me.updates = {};
        me._isNew = Object.keys(data).length === 0;
    }
    Model.prototype.sync = function (data) {
        var me = this;
        me.data = data;
        me.updates = {};
        me._isNew = false;
        return me;
    };
    Model.prototype.isNew = function () {
        var me = this;
        return me._isNew;
    };
    Model.prototype.getValue = function (field, defaultValue) {
        if (defaultValue === void 0) { defaultValue = null; }
        var me = this;
        if (me.updates.hasOwnProperty(field)) {
            return me.updates[field];
        }
        else if (me.data.hasOwnProperty(field)) {
            return me.data[field];
        }
        else {
            return defaultValue;
        }
    };
    Model.prototype.setValue = function (field, value) {
        var me = this;
        me.updates[field] = value;
        return me;
    };
    Model.prototype.getUpdates = function () {
        var me = this;
        return me.updates;
    };
    Model.prototype.getInitial = function () {
        var me = this;
        return me.data;
    };
    Model.prototype.getData = function () {
        var me = this, r = {};
        return Object.assign({}, me.data, me.updates);
    };
    Model.prototype.toJsonString = function () {
        var me = this;
        return JSON.stringify(me.getData());
    };
    return Model;
}());
exports.Model = Model;
//# sourceMappingURL=Model.js.map