"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Module_1 = require("./Module");
var User_1 = require("./User");
var SecurityProvider = (function (_super) {
    __extends(SecurityProvider, _super);
    function SecurityProvider(app, config) {
        var _this = _super.call(this, app) || this;
        var me = _this;
        me.config = config;
        return _this;
    }
    SecurityProvider.prototype.addRedirectToEntry = function (url) {
        var me = this;
        me.express.get(url, function (req, res, next) {
            res.redirect(me.config.entryURLProvider(req));
        });
        return me;
    };
    SecurityProvider.prototype.logoutRequestHandler = function (req, res, next) {
        var me = this, loginUrl = me.config.loginURLProvider(req);
        me.app.destroySession(req, function () {
            res.redirect(loginUrl);
        });
    };
    SecurityProvider.prototype.activate = function () {
        var me = this;
        me.express.get(me.config.entryURLProvider(), me.allowAuthenticatedOnly(), me.config.entryRequestHandler);
        me.express.get(me.config.loginURLProvider(), me.allowAnonymousOnly(), me.config.loginRequestHandler);
        me.express.post(me.config.loginURLProvider(), me.allowAnonymousOnly(), me.config.loginRequestHandler);
        me.express.get(me.config.logoutURLProvider(), me.allowAuthenticatedOnly(), me.logoutRequestHandler.bind(me));
        me.express.post(me.config.logoutURLProvider(), me.allowAuthenticatedOnly(), me.logoutRequestHandler.bind(me));
    };
    SecurityProvider.prototype.allowAuthenticatedOnly = function () {
        var me = this;
        return function (req, res, next) {
            var user = me.app.getCurrentUser(req, User_1.SystemUser);
            if (user.isGuest()) {
                var loginUrl = me.config.loginURLProvider(req);
                me.app.clearSession(req, function () {
                    res.redirect(loginUrl);
                });
            }
            else {
                next();
            }
        };
    };
    SecurityProvider.prototype.allowAnonymousOnly = function () {
        var me = this;
        return function (req, res, next) {
            var user = me.app.getCurrentUser(req, User_1.SystemUser);
            if (user.isGuest()) {
                next();
            }
            else {
                var referer = me.app.getReferer(req);
                if (referer && req.originalUrl !== referer) {
                    res.redirect(referer);
                }
                else {
                    res.redirect(me.config.entryURLProvider(req));
                }
            }
        };
    };
    return SecurityProvider;
}(Module_1.Module));
exports.SecurityProvider = SecurityProvider;
//# sourceMappingURL=SecurityProvider.js.map