/// <reference types="express" />
import { Request, RequestHandler } from "express";
export interface DictionaryInterface {
    [name: string]: any;
}
export interface ModelInterface {
    getData(): DictionaryInterface;
}
export interface ModelConsumerInterface<T> {
    new (data?: DictionaryInterface): T;
}
export interface UserInterface {
    isGuest: () => boolean;
}
export interface SecurityProviderConfig {
    entryURLProvider: (req?: Request) => string;
    loginURLProvider: (req?: Request) => string;
    logoutURLProvider: (req?: Request) => string;
    loginRequestHandler: RequestHandler;
    entryRequestHandler: RequestHandler;
}
